
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;



// Die folgende Klasse zur Kapselung einiger statischer Methoden

/*  METHODEN:

// DIALOGFENSTER
    public static void Error( String sTitle, String sMessage) {
    public static void Message( String sTitle, String sMessage) {
    public static boolean YesNo( String sTitle, StringsMessage) {
    public static int YesNoEsc( String sTitle, String sMessage) {
    public static int FreeButtons( String sTitle, String sMessage, Buttons []);

    public static boolean OkEsc( String sTitle, String sMessage) {
        // gibt einen Klartext fr die Konvertierung aus
    public static String getErrorCode() {
    public static String getInput( String sTitle, String sMessage) {
    public static String getInput( String sTitle, String sMessage, String sInput) {

      // Welche Maustaste wurde gedrckt ?
    public static int getButton(MouseEvent e) {



// AUSGABE EINER FORMATIERTEN ZAHL
      Parameter nk beschreibt die Nachkommastelle
    public static String DStr(double d, int nk) {
    public static String IStr2(int iZahl) {
    public static String LStr2(long lZahl) {
    public static String Komma2Point(String szZ) {
    public static String Point2Komma(String szZ) {

// DATEI FUNKTIONEN
    public static String changeFileExt(String szDateiname, String szExt) {
    public static String getFileExt(String szDateiname) {
    public static String getFileNameExt(String szDateiname) {

     // Schneidet die Extension ab
    public static String getFileName(String szDateiname) {
    public static boolean FileExists(String szDateiname) {

    public static void centerScreen(java.awt.Window frame, java.awt.Dimension preset) {

*/
public class Basis {
    // 

    // Damit braucht man nicht die Konstanten aus JOptionPane referenzieren
    public static final int YES = 1;
    public static final int NO = 2;
    public static final int CANCEL = 3;


    /**
    * description: Zeigt eine Fehlermeldung an   
    * @see Message, Yes-No, Yes-No-Esc, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return keinen
    * @exception keine
    */
  public static void Error(String sMessage, String sTitle) {
    JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.DEFAULT_OPTION,
      JOptionPane.ERROR_MESSAGE);  // Symbol
    /*  Optionen der Schalter:
         DEFAULT_OPTION    Ok
         YES_NO_OPTION
         YES_NO_CANCEL_OPTION
         OK_CANCEL_OPTION
     */
     /*  Symbole:
      ERROR_MESSAGE
      INFORMATION_MESSAGE
      WARNING_MESSAGE
      QUESTION_MESSAGE
      PLAIN_MESSAGE
     */

  } // Error

    /**
    * description: Zeigt eine Nachricht an   
    * @see Message, Yes-No, Yes-No-Esc, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return keinen
    * @exception keine
    */
  public static void Message(String sMessage, String sTitle) {
    JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.DEFAULT_OPTION,
      JOptionPane.INFORMATION_MESSAGE);  // Symbol
    /*  Optionen der Schalter:
         DEFAULT_OPTION    Ok
         YES_NO_OPTION
         YES_NO_CANCEL_OPTION
         OK_CANCEL_OPTION
     */
     /*  Symbole:
      ERROR_MESSAGE
      INFORMATION_MESSAGE
      WARNING_MESSAGE
      QUESTION_MESSAGE
      PLAIN_MESSAGE
     */

  } // Message

    /**
    * description: Zeigt einen Ja-Nein-Dialog   
    * @see Message, Error, Yes-No-Esc, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return boolean
    * @exception keine
    */
  public static boolean YesNo(String sMessage, String sTitle) {
    int retcode;
    retcode = JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.YES_NO_OPTION,
      JOptionPane.QUESTION_MESSAGE);  // Symbol

    switch (retcode) {
       case JOptionPane.YES_OPTION:
         // ja, nderungen speichern
         return true;
       case JOptionPane.NO_OPTION:
         return false;
       case JOptionPane.CANCEL_OPTION:
       default:
         // abbrechen
         return false;
    }
  } // YesNo


    /**
    * description: Zeigt einen Ja-Nein-Abbruch-Dialog   
    * @see Message, Error, Yes-No, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return int YES_OPTION, NO_OPTION, CANCEL_OPTION
    * @exception keine
    */
  public static int YesNoEsc( String sMessage, String sTitle) {
    int retcode;
    retcode = JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.YES_NO_CANCEL_OPTION,
      JOptionPane.QUESTION_MESSAGE);  // Symbol

    switch (retcode) {
       case JOptionPane.YES_OPTION:
         // ja, nderungen speichern
         return YES;
       case JOptionPane.NO_OPTION:
         return NO;
       case JOptionPane.CANCEL_OPTION:
       default:
         return CANCEL;
    }
  } // YES NO ESC

  
    /**
    * description: Zeigt einen Dialog mit frei definiertem Schalter
    * @see Message, Error, Yes-No, Yes-No-Esc, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage, String buttons[]
    * @return int Returncode von JOptionPane
    * @exception keine
    */
  public static int FreeButtons(String sMessage, String sTitle,  String buttons[]) {
    int retcode;
    retcode = JOptionPane.showOptionDialog(
           null, sMessage,sTitle,
           JOptionPane.DEFAULT_OPTION,
           JOptionPane.QUESTION_MESSAGE,
           null, buttons, buttons[0]);

    return retcode;
  }  // FreeButtons





    /**
    * description: Zeigt einen Dialog Ok-Esc an
    * @see Message, Error, Yes-No, Yes-No-Esc, Ok-Esc
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage, String buttons[]
    * @return boolean
    * @exception keine
    */
  public static boolean OkEsc(String sMessage, String sTitle) {
    int retcode;
    retcode = JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.OK_CANCEL_OPTION,
      JOptionPane.INFORMATION_MESSAGE);  // Symbol

    switch (retcode) {
       case JOptionPane.OK_OPTION:
         // ja, nderungen speichern
         return true;
       case JOptionPane.CANCEL_OPTION:
       default:
         // abbrechen
         return false;
    }
  } // Ok ESC


    /**
    * description: Eingabe eines Strings
    * @see getInput
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage
    * @return String
    * @exception keine
    */
  public static String getInput(String sMessage, String sTitle) {
    return JOptionPane.showInputDialog(null, sTitle, sMessage, 1);
  } // getInput



    /**
    * description: Eingabe eines Strings mit Vorgabe
    * @see getInput
    *
    * @version     1.0  07.07.2002
    * @author      Michael Wilhelm HS Harz, FB AI
    * @param String sTitle, String sMessage, String sInput
    * @return String
    * @exception keine
    */
  public static String getInput(String sMessage, String sTitle, String sInput) {
    return (String) JOptionPane.showInputDialog( null,sMessage, sTitle, JOptionPane.PLAIN_MESSAGE,
       null, null, sInput);
  } // getInput

  




   
    /**
    * description: konvertiert einen double in einem String
    *              Parameter nk beschreibt die Nachkommastelle       
    *              nk = Anzahl der Nachkommastellen
    * @see IStr2, LStr2
    *
    * @version     1.0  07.07.2002
    * @author Michael Wilhelm HS Harz, FB AI
    * @param double d, int nk
    * @return String
    * @exception keine
    */
    public static String DStr(double d, int nk) {
        java.text.NumberFormat NF = java.text.NumberFormat.getInstance();
        NF.setMinimumFractionDigits(nk);
        NF.setMaximumFractionDigits(nk);
        return NF.format(d);
    }  // DStr

    
    
  /*  BESCHREIBUNG     : konvertiert ein int einen String mit mindestens   */
  /*                     zwei gltigen Ziffern                             */
  /*                     12     --->   "12"                                */
  /*                     123    --->   "123"                               */
  /*                     2      --->   "02"                                */
  /*                     1      --->   "01"                                */
  /*                     8      --->   "08"                                */

    /**
    * description: wandelt den int Wert in einen zweistelligen String um 
    *              Example 1 -> 01   123 ->  123
    * @see DStr, LStr2
    *
    * @version     1.0  07.07.2002
    * @author Michael Wilhelm HS Harz, FB AI
    * @param int iZahl
    * @return String
    * @exception keine
    */
    public static String IStr2(int iZahl) {
        String s;
        java.text.NumberFormat NF = java.text.NumberFormat.getInstance();
        s = NF.format(iZahl);
        if (s.length() < 2) s = "0" + s;
        return s;
    }  // IStr2



    /**
    * description: wandelt den long Wert in einen zweistelligen String um 
    *              Example 1 -> 01   123 ->  123
    * @see DStr, Str2
    *
    * @version     1.0  07.07.2002
    * @author Michael Wilhelm HS Harz, FB AI
    * @param long iZahl
    * @return String
    * @exception keine
    */
    public static String LStr2(long lZahl) {
        String s;
        java.text.NumberFormat NF = java.text.NumberFormat.getInstance();
        s = NF.format(lZahl);
        if (s.length() < 2) s = "0" + s;
        return s;
    }  // LStr2


    /**
    * description: konvertiert alle Kommas in einem String
    * @see Point2Komma
    *
    * @version     1.0  07.07.2002
    * @author Michael Wilhelm HS Harz, FB AI
    * @param String sText
    * @return String
    * @exception keine
    */
    public static String Komma2Point(String sText) {
        return sText.replace(',', '.');
    } // siehe Komma2Point



    /**
    * description: konvertiert alle Punkte in einem String
    * @see Komma2Point2
    *
    * @version     1.0  07.07.2002
    * @author Michael Wilhelm HS Harz, FB AI
    * @param String sText
    * @return String
    * @exception keine
    */
    public static String Point2Komma(String sText) {
        return sText.replace('.', ',');
    }




    
    
    // Datei Methoden

    //   Beispiel
    //   szMom = bas.ChangeFileExt(szUFileName, ".MOM");

    /**
    * description: ndert die Extention eines Dateinamens (TXT bzw. DAT)
    * @see #CheckFileName
    * @see #getFileExt ndern der Dateiwerweiterung  TXT  -> DAT
    *
    * @version     1.0  07.07.2002
    * @author Michael Wilhelm HS Harz, FB AI
    * @param String sFileName, String sExt
    * @return String
    * @exception keine
    * @see #CheckFileName
    * @see #ChangeFileExt
    * @see #getFileName extrahiert den Dateinamen ohne Pfad
    * @see #FileExists
    */
    public static String changeFileExt(String sFileName, String sExt) {
        String sErgFile;
        int k;
        sErgFile = "";
        File f = null;
        //File.pa
        try {
            // eventuell kann auch f.pathSeparatorChar verwendet werden
            // suche letzten Punkt
            k = sFileName.lastIndexOf(".");
            if (k == -1){ // kein Punkt vorhanden
              return new String(sFileName+sExt);
            }
            else {
              int n = sFileName.length();
                // beginIndex    EndIndex
              sErgFile = sFileName.substring(0,k);  // zhlt von 0
              return new String(   sErgFile+sExt);
            }

        }
        catch (Exception e) {
        }
        return sErgFile;
    }
    //   Beispiel
    //   szMom = bas.getFileExt(szUFileName);
    //   szMom = ".MOM"




    /**
    * description: holt die Extention eines Dateinamens (TXT bzw. DAT)
    * @see #CheckFileName
    * @see #changeFileExt
    *
    * @version     1.1  31.01.2006
    * @author Michael Wilhelm HS Harz, FB AI
    * @param String sFileName, String sExt
    * @return String
    * @exception keine
    * @see #CheckFileName
    * @see #ChangeFileExt
    * @see #getFileName extrahiert den Dateinamen ohne Pfad
    * @see #FileExists
    */
    // besser mit lastIndexOf(Stringstr)
    public static String getFileExt(String sFileName) {
        int k, i, n;
        n = sFileName.length();
        // suche von hinten erstes Auftreten eines Punktes
        k = sFileName.lastIndexOf(".");
        if (k == -1) // kein Punkt vorhanden
            return new String("");
        else {
            // substring zhlt von NULL
            // Anfangsindex   EndIndex
            String s;
            s = sFileName.substring(k, n);
            return sFileName.substring(k, n);
        }
    } // getFileExt
    
    

    /**
    * GetFileNameExt
    * description: holt den Namen und die Extention eines Dateinamens, ohne Pfad
    * @return String Name+Ext
    * @param String sFileName
    * @exception none
    * @version      1.1, 31.01.2006
    * @author Michael Wilhelm HS Harz, FB AI
    * @use Example
    * @see #CheckFileName
    * @see #ChangeFileExt
    * @see #getFileName extrahiert den Dateinamen ohne Pfad
    * @see #FileExists
    */
    public static String getFileNameExt(String sFileName) {
        int k, n;
        n = sFileName.length();
        k = sFileName.lastIndexOf("\\");
        if (k == -1) {
            // test mit /
            k = sFileName.lastIndexOf("/");
            if (k == -1)
                return sFileName;
            else {
                  // beginIndex   endIndex
                return sFileName.substring(k+1, n); // ??????  n-1 ist zu klein            
            }
        }
        else {
              // beginIndex   endIndex
            return sFileName.substring(k+1, n); // ??????  n-1 ist zu klein                        
        }
    }  // getFileNameExt

    
    /**
    * GetFileNameExt
    * description: holt nur den Namen, mit Pfad, ohne Extention
    * @return String Name
    * @param String sFileName
    * @exception none
    * @version      1.1, 31.01.2006
    * @author Michael Wilhelm HS Harz, FB AI
    * @use Example
    * @see #CheckFileName
    * @see #ChangeFileExt
    * @see #getFileNameExt
    * @see #FileExists
    */
    public static String getFileName(String sFileName) {
        int k, i, n;
        n = sFileName.length();
        k = sFileName.lastIndexOf(".");
        if (k == -1)
            return sFileName;
        else
            return sFileName.substring(0, k);  // ohne Punkt
    }  // getFileName

    

    /**
    * FileExists
    * description: prft, ob die Datei existiert
    * @return boolean
    * @param String sFileName
    * @exception none
    * @version      1.1, 31.01.2006
    * @author Michael Wilhelm HS Harz, FB AI
    * @use Example
    * @see #CheckFileName
    * @see #ChangeFileExt
    * @see #getFileNameExt
    */
    public static boolean FileExists(String sFileName) {
        File f = null;
        try {
            // evnetuell kann auch f.pathSeparatorChar verwendet werden
            f = new File(sFileName);
            if (f.exists())
                return true;
            else
                return false;
        }
        catch (Exception e) {
            return false;
        }
    }  // FileExists


    
    

    /**
    * CheckFileName
    * description: Prft, ob die Datei ein gltiges Format hat
    * @return boolean 
    * @param String sFileName
    * @exception none
    * @version      1.1, 31.01.2006
    * @author Michael Wilhelm HS Harz, FB AI
    * @use Prft, ob der Dateiname gltig ist 
    * @see #getFileName
    * @see #ChangeFileExt
    */
  /*  VERFAHREN        :  Check ob folgende Zeichen vorhanden sind,        */
  /*                      dann falsch                                      */
  /*                      \  /   :  ?  *  "  <  >  |                       */
  /*                      Suche geschieht mit der Methode indexOf          */
  /*                                                                       */
    public static boolean CheckFileName(String sFileName) {
        if (sFileName.length() == 0) {
            return false;
        }
        else {
            int i;
            i = sFileName.indexOf('\\', 0);
            if (i > 0) return false;
            i = sFileName.indexOf('/', 0);
            if (i > 0) return false;
            i = sFileName.indexOf(':', 0);
            if (i > 0) return false;
            i = sFileName.indexOf('?', 0);
            if (i > 0) return false;
            i = sFileName.indexOf('*', 0);
            if (i > 0) return false;
            i = sFileName.indexOf('"', 0);
            if (i > 0) return false;
            i = sFileName.indexOf('<', 0);
            if (i > 0) return false;
            i = sFileName.indexOf('>', 0);
            if (i > 0) return false;
            i = sFileName.indexOf('|', 0);
            if (i > 0) return false;
            return true;
        }
    } //  CheckFileName



    /**
    * getButton
    * description: Bestimmen, welche Maustaset gedrckt wurde Example
    * @return int taste, links=1  mitte=2, rechts=3
    * @param MouseEvent e
    * @exception none
    * @version      1.1, 31.01.2006
    * @author Michael Wilhelm HS Harz, FB AI
    */
    public static int getButton(MouseEvent e) {
        int mode = e.getModifiers();
        if ((mode & e.BUTTON2_MASK) > 0) {
            return 2;
        }
        if ((mode & e.BUTTON3_MASK) > 0) {
            return 3;
        }
        return 1;
    } // getButton


}  // basis


