import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Vector;

import java.math.BigDecimal;

public class Dbs_QueriesExecute {
	
    public static String SQL_getDept() {
           return "SELECT pindex, city, country FROM  department ORDER BY city;";
    }
	
    public static ObservableCollection_Dept getItemsFromDept() {
    	try {
	        ObservableCollection_Dept dept_class = new ObservableCollection_Dept();
	        ArrayList<ModelDept> dept_items = dept_class.getItems();
	        String sql = SQL_getDept();
	        Dbs dbs = Dbs.getInstance();
	        ModelDept dept = null;	        
			ResultSet  rs = dbs.executeQuery(sql);
			if (rs==null) return dept_class;
			
	        while( rs.next() ) {
	        	dept = new ModelDept();            
	            dept.setPindex(   Long.parseLong(rs.getString( 1 ) ));
	            String s2 = rs.getString( 2 );
	            String s3 = rs.getString( 3 );
	            dept.setCity(rs.getString( 2 ));
	            dept.setCountry(rs.getString( 3 ));
	            dept.newAttrib = false;
	            dept.modifyAttrib = false;
	            dept_items.add( dept );
	        }	        
	        return dept_class;
    	} catch (SQLException e) {
			Basis.Error( e.toString() , "Fehler beim Starten einer SQL-Anweisung");
		}
    	return null;
    }
	
    
    
    public static String SQL_getEmployees(String lastnameFilter) {
    	String where = "";
    	if (lastnameFilter.length()>0) {
    		where = "WHERE lastname LIKE '"+lastnameFilter+"%'";
    	}
  		return "SELECT Pindex, firstname, lastname,  monthlysalary, deptindex FROM  employee \n"+
    	   where +"  ORDER BY lastname, firstname;";
 }
	
 public static ObservableCollection_Employee getItemsFromEmployees(String lastnameFilter) {
 	try {
	        ObservableCollection_Employee empl_class = new ObservableCollection_Employee();
	        ArrayList<ModelEmployee> empl_items = empl_class.getItems();
	        String sql = SQL_getEmployees(lastnameFilter);
	        Dbs dbs = Dbs.getInstance();
	        ModelEmployee empl = null;	        
			ResultSet  rs = dbs.executeQuery(sql);
			if (rs==null) return empl_class;
			
	        while( rs.next() ) {
	        	empl = new ModelEmployee();            
	            empl.setPindex(   Long.parseLong(rs.getString( 1 ) ));
	            empl.setFirstname(rs.getString( 2 ));
	            empl.setLastname(rs.getString( 3 ));
	            empl.setMonthlysalary( new BigDecimal( rs.getString( 4 )));
	            empl.setDeptindex( Long.parseLong(rs.getString( 5 ) ));
	            empl.newAttrib = false;
	            empl.modifyAttrib = false;
	            empl_items.add( empl );
	        }	        
	        return empl_class;
 	} catch (SQLException e) {
			Basis.Error( e.toString() , "Fehler beim Starten einer SQL-Anweisung");
		}
 	return null;
 }

 
 public static void deleteModelEmployee(ModelEmployee empl) {
     Dbs dbs = Dbs.getInstance();
     String sql = "DELETE FROM Employee WHERE pindex=" + empl.getPindex() + ";";
     dbs.changeDBS(sql);
 }

 public static void insertModelEmployee(ModelEmployee empl) {
     Dbs dbs = Dbs.getInstance();
     String sql = "INSERT INTO Employee(pindex, firstname, lastname, monthlysalary, deptindex) " +
             "Values (" + empl.getPindex() + ", "
               + empl.getFirstnameQuote() + ", "
               + empl.getLastnameQuote() + ", "
               + empl.getMonthlysalary() + ", "
               + empl.getDeptindex() + ");";
     dbs.changeDBS(sql);
 }

 public static void updateModelEmployee(ModelEmployee empl) {
     Dbs dbs = Dbs.getInstance();
     String sql = "UPDATE Employee " +
          " SET "
          + " firstname=" + empl.getFirstnameQuote() + ", "
          + " lastname=" + empl.getLastnameQuote() + ", "
          + " monthlysalary=" + empl.getMonthlysalary() + ", "
          + " Deptindex= " + empl.getDeptindex() + " " +
          " WHERE pindex=" + empl.getPindex() + ";";
     dbs.changeDBS(sql);
 }

	public static DataTable getSQL(String sql) {
		 DataTable dt = new DataTable();
		 Dbs dbs = Dbs.getInstance();
		 try {
			 ResultSet rs= dbs.executeQuery(sql);
			 if (rs==null) {
				 return dt;
			 }
			 ResultSetMetaData rsmd = rs.getMetaData(); // Anz der Spalten
			 int n=rsmd.getColumnCount();
			 for (int i=1; i<=n; i++) {
				 dt.headers.add( rsmd.getColumnName(i)  );
			 }
			 while (rs.next() ) {
				 ArrayList<String> columns = new ArrayList<String>();
				 for (int i=1; i<=n; i++) {
					 columns.add(  rs.getString(i) );
				 }
				 dt.rows.add(columns);
			 }
		 } catch(SQLException e) {
			 Basis.Error(e.toString(), "Fehler beim Ausfhren einer SQL-Anweisung");
		 }
		 return dt;
	}

}
