
import java.util.*;

// diese Klasse kapselt alle eingelesenen Employee
// speichert die gelschten Employees
// Speichert die nderungen (update, delete, new)
public class ObservableCollection_Employee {

	private ArrayList<ModelEmployee> items = new ArrayList<ModelEmployee>();
	private ArrayList<ModelEmployee> deleteitems = new ArrayList<ModelEmployee>();
	
	// fr JTable
	public ArrayList<ModelEmployee> getItems() {
		return items;
	}
    
	public int getDeleteItemsCount() {
		return deleteitems.size();
	}
	
	public void delete(ModelEmployee item) {
		if (items.remove(item)) {
			deleteitems.add(item);
		}
	}
	
	public void save2Database() {
		Dbs dbs = Dbs.getInstance();
		for (ModelEmployee empl: deleteitems) {
			Dbs_QueriesExecute.deleteModelEmployee(empl);
		}
		deleteitems.clear();
		for (ModelEmployee empl: items) {
			if (empl.newAttrib) {
				Dbs_QueriesExecute.insertModelEmployee(empl);
				empl.newAttrib=false;
				empl.modifyAttrib=false;
			}
			else if (empl.modifyAttrib) {
				Dbs_QueriesExecute.updateModelEmployee(empl);
				empl.modifyAttrib=false;
			}
		}
		
	}  // save2Database
	

}
