
/*
java.lang.Object
  extended by oracle.sql.Datum
      extended by oracle.sql.NUMBER
*/

public class ModelDept  extends ModelBase {
	
	private long pindex=0;
	private String city="";
	private String country="";

    public ModelDept() {
    	
    }
	
    public ModelDept(long pindex, String city, String country) {
    	this.pindex = pindex;
    	this.city = city;
    	this.country = country;
    }
	

    public long getPindex() {
        return pindex; 
    }    
    public void setPindex(long value) {
        if (value != pindex) {
            //NotifyPropertyChanged("Pindex");
            modifyAttrib = true;
            pindex = value;
        }
    }       
    
    public String getCity() {
            return city;
    }    
    public void setCity(String value) {
        if (!city.equals(value)) {
            // NotifyPropertyChanged("Firstname");
            modifyAttrib = true;
            city = value;
        }
    }
    public String getCityQuote() {
        return "'" + city + "'";
    }


    public String getCountry() {
         return country; 
    }
    public void setCountry(String value) {
    	if (!country.equals(value)) {
            modifyAttrib = true;
            country = value;
        }
    }
    public String getCountryQuote() {
        return "'" + country + "'";
    }
    
    @Override
    public String toString() {
    	return city;
    }
    

}
