
/*
java.lang.Object
  extended by oracle.sql.Datum
      extended by oracle.sql.NUMBER
*/

import java.math.BigDecimal;
import java.util.ArrayList;



public class ModelEmployee  extends ModelBase {
	
	public static ArrayList<ModelDept> dept_Items=null;
	
	private long pindex;
	private String firstname="";
	private String lastname="";
	private BigDecimal monthlysalary = new BigDecimal("0.0"); // Datentyp Number
	private long deptindex=-1;
	private String dept="";  // statt deptIndex
	
	public ModelEmployee() {
		
	}
    public ModelEmployee(long pindex, String firstname, String lastname, BigDecimal monthlysalary, long deptIndex) {
    	this.pindex = pindex;
    	this.firstname = firstname;
    	this.lastname = lastname;
    	this.monthlysalary = monthlysalary;
    	this.deptindex = deptIndex;
    	
    	for(ModelDept dept_loop : dept_Items ) {
    		if (dept_loop.getPindex()==deptindex) {
    			dept = dept_loop.getCity();
    			break;
    		}
    	}
    	
    }
	

    public long getPindex() {
        return pindex; 
    }    
    public void setPindex(long value) {
        if (value != pindex) {
            //NotifyPropertyChanged("Pindex");
            modifyAttrib = true;
            pindex = value;
        }
    }       
    
    public String getFirstname() {
            return firstname;
    }    
    public void setFirstname(String value) {
        if (value != firstname) {
            // NotifyPropertyChanged("Firstname");
            modifyAttrib = true;
            firstname = value;
        }
    }
    public String getFirstnameQuote() {
        return "'" + firstname + "'";
    }


    public String getLastname() {
         return lastname; 
    }
    public void setLastname(String value) {
        if (value != lastname) {
            //NotifyPropertyChanged("Lastname");
            modifyAttrib = true;
            lastname = value;
        }
    }
    public String getLastnameQuote() {
        return "'" + lastname + "'";
    }
    
    public BigDecimal getMonthlysalary() {
         return monthlysalary; 
    }
    public void setMonthlysalary(BigDecimal value) {
        if (value != monthlysalary) {
            //NotifyPropertyChanged("Monthlysalary");
            modifyAttrib = true;
            monthlysalary = value;
        }
    }
    


    public long getDeptindex() {
        return deptindex; 
    }  
    public void setDeptindex(long index) {
        deptindex = index; 
        for(ModelDept dept_loop : dept_Items ) {
    		if (dept_loop.getPindex()==deptindex) {
    			dept = dept_loop.getCity();
    			break;
    		}
    	}
    }

    public String getDept() {
         return dept; 
    }
}
