import javax.swing.*;

import java.awt.*;


import java.sql.*;

// schalter
import java.awt.event.*;

import javax.swing.table.*;

import java.util.ArrayList;
import java.util.Vector;
import javax.swing.event.TableModelEvent;

@SuppressWarnings("serial")
public class WEmployee extends JDialog implements ActionListener{
	
    private final JButton bnFirst = new JButton("Erster", new ImageIcon("first.png"));
    private final JButton bnPrev = new JButton("Vorheriger", new ImageIcon("previous.png"));
    private final JButton bnNext = new JButton("Nchster", new ImageIcon("next.png"));
    private final JButton bnLast = new JButton("Letzter", new ImageIcon("last.png"));
    private final JButton bnEdit = new JButton("ndern", new ImageIcon("edit.png"));
    private final JButton bnInsert = new JButton("Einfgen", new ImageIcon("plus.png"));
    private final JButton bnDelete = new JButton("Lschen", new ImageIcon("delete.png"));
	
	private JTable table=null; 
	  
	private JTextField lastnameFilter= new JTextField();
	
	private TableModel dataModel;  // siehe Update
	
	ObservableCollection_Employee empl_class = null;  // WrapperKlasse new,delete,update
    ArrayList<ModelEmployee> empl_items = null;
    
    ArrayList<String> headers = new ArrayList<String>();
	
	
	public WEmployee(Frame parent) {
		super(parent);
		setDefaultCloseOperation( JDialog.DO_NOTHING_ON_CLOSE );  // WindowClosing
		setModal(true);
		setSize(800,400);
	    setLocation(400,40);
	    setGUI();
	    headers.add("Pindex");
	    headers.add("Vorname");
	    headers.add("Nachname");
	    headers.add("Monatsgehalt");
	    headers.add("Abteilung");
	    
	    // Anzeige der Department-bezeichnung statt DeptIndex
	    ModelEmployee.dept_Items = Dbs_QueriesExecute.getItemsFromDept().getItems();
	    
	    setVisible(true);  // muss am Schluss kommen
	}
	    
	private void setGUI() {
	      setLayout( new GridBagLayout() );	
	      this.setTitle("Tabelle der Mitarbeiter");
	      // setToolBar();
	      
	      JPanel panelTop = new JPanel();
	      panelTop.setLayout( new GridBagLayout() );
	      
	      JLabel label1 = new JLabel("Nachname Filter");
	      label1.setFont( new Font("Arial", Font.BOLD,16));
	      panelTop.add(label1, new GridBagConstraints(
	    		  0, 0, 1, 1, 0.0, 0.0
	              ,GridBagConstraints.WEST, 
	              GridBagConstraints.NONE, 
	              new Insets(0,20,0,0), 0,0 ));

	      lastnameFilter.setFont( new Font("Arial", Font.BOLD,16));
	      panelTop.add(lastnameFilter, new GridBagConstraints(
	    		  1, 0, 1, 1, 100.0, 0.0
	              ,GridBagConstraints.WEST, 
	              GridBagConstraints.HORIZONTAL, 
	              new Insets(0,20,0,20), 0,0 ));
	      
	      JButton bnStart = new JButton("Start SQL");
	      bnStart.setFont( new Font("Arial", Font.BOLD,16));
	      bnStart.addActionListener(this);
	      bnStart.setActionCommand("Start");
	      panelTop.add(bnStart, new GridBagConstraints(
	    		  2, 0, 1, 1, 0.0, 0.0
	              ,GridBagConstraints.WEST, 
	              GridBagConstraints.NONE, 
	              new Insets(0,20,0,20), 0,0 ));
	      
	      
	      add(panelTop, new GridBagConstraints(
	    		  0, 0, 1, 1, 100.0, 0.0
	              ,GridBagConstraints.WEST, 
	              GridBagConstraints.HORIZONTAL, 
	              new Insets(20,0,20,0), 0,0 ));
	      
	      add(getToolBars(), new GridBagConstraints(
	    		  0, 1, 1, 1, 100.0, 0.0
	              ,GridBagConstraints.WEST, 
	              GridBagConstraints.HORIZONTAL, 
	              new Insets(20,0,20,0), 0,0 ));
	      
	      table = createTable();
	      table.setFont( new Font("Monospaced", Font.PLAIN,18) );
	      add(new JScrollPane(table), new GridBagConstraints(
	    		  0, 2, 1, 1, 100.0, 100.0
	              ,GridBagConstraints.WEST, 
	              GridBagConstraints.BOTH, 
	              new Insets(0,0,0,0), 0,0 ));
	      
	      this.addWindowListener(new java.awt.event.WindowAdapter() {

	          public void windowActivated(WindowEvent e) {
	            //this_windowActivated(e);
	          }

	          public void windowClosed(WindowEvent e) {
	            //this_windowClosed(e);
	          }

	          public void windowClosing(WindowEvent e) {
	            this_windowClosing(e);
	          }

	          public void windowDeactivated(WindowEvent e) {
	            //this_windowDeactivated(e);
	          }

	          public void windowDeiconified(WindowEvent e) {
	        	  //this_windowDeiconified(e);
	          }

	          public void windowIconified(WindowEvent e) {
	        	  //this_windowIconified(e);
	          }

	          public void windowOpened(WindowEvent e) {
	        	  //this_windowOpened(e);
	          }
	        });	      
	}  // setGUI
	
	

	  private JToolBar getToolBars() {
	    JToolBar toolBar = new JToolBar();

	    toolBar.add(bnFirst);
	    toolBar.add(bnPrev);
	    toolBar.add(bnNext);
	    toolBar.add(bnLast);
	    toolBar.addSeparator( new Dimension(20,10) );
	    toolBar.add(bnEdit);
	    toolBar.add(bnDelete);
	    toolBar.add(bnInsert);
	    bnFirst.addActionListener(this);
	    bnPrev.addActionListener(this);
	    bnNext.addActionListener(this);
	    bnLast.addActionListener(this);
	    bnEdit.addActionListener(this);
	    bnInsert.addActionListener(this);
	    bnDelete.addActionListener(this);    
	    bnFirst.setActionCommand("First");
	    bnPrev.setActionCommand("Prev");
	    bnNext.setActionCommand("Next");
	    bnLast.setActionCommand("Last");
	    bnEdit.setActionCommand("Edit");
	    bnInsert.setActionCommand("Insert");
	    bnDelete.setActionCommand("Delete");   
	    
	    return toolBar;
	  } // getToolBars
	
	
    // createTable
 public JTable createTable() {
   // Create a model of the data.
       dataModel = new AbstractTableModel() {
           // These methods always need to be implemented.
           public int getColumnCount() {
               //System.out.println( " **** AnzCol: "+_tupel.size() );
             return headers.size();
           }
           public int getRowCount() {
        	   if (empl_items==null)  // Am Anfang noch nicht gesetzt
        		   return 0;
        	   else
        		   return empl_items.size();
           }

               // Speicherung mittels Vector und Vector
           public Object getValueAt(int row, int column) {
               ModelEmployee empl = (ModelEmployee) empl_items.get(row);
               switch (column) {
              	case 0: return empl.getPindex();
               	case 1: return empl.getFirstname();
               	case 2: return empl.getLastname();
               	case 3: return empl.getMonthlysalary();
                //case 4: return empl.getDeptindex();
               	case 4: return empl.getDept();
               	default: return "XXXXXXXXX";
               }                   
           }

           public String getColumnName(int column) {
               if ( (column)< headers.size() ) {
					return headers.get(column);
               } else {
                   return "X";
               }
           }
           
           public Class getColumnClass(int column) {
             return getValueAt(0, column).getClass();
           }
           
           public boolean isCellEditable(int row, int col) {
             return false;
           }
          
        };

    
    JTable table = new JTable(dataModel); // , _TableColModel);

    table.setFont( new Font("Arial", Font.PLAIN,24) );
    table.setRowHeight(30);
    table.setAutoCreateColumnsFromModel(true);
    
    table.setAutoCreateRowSorter(true);  
    
    //table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
    table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
    return table;
 } // createTable
 
 
 	@Override
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		switch (cmd) {
			case "Start": startSQL();
					break;
			case "First":firstEmployee();
				break;
			case "Prev":prevEmployee();
				break;
			case "Next":nextEmployee();
				break;
			case "Last":lastEmployee();
				break;
			case "Edit": editEmployee();
				break;
			case "Insert": insertEmployee();
				break;
			case "Delete": deleteEmployee();
				break;
			default: Basis.Error("Fehlerhafte case-Anweisung in actionPerformed", "Main");
					break;
		}
	}  // actionPerformed 
	
 	 private void selectAndScroll(int row) {
         Rectangle cellRect = table.getCellRect(row, 0, true);
         table.scrollRectToVisible(cellRect);
         table.clearSelection();
         table.setRowSelectionInterval(row, row);        
     }  
 	 
 	private void firstEmployee() {
		selectAndScroll(0);
	}

	private void prevEmployee() {
		int row = table.getSelectedRow();
        if (row>0) {
            selectAndScroll(row-1);
        }	
    }

	private void nextEmployee() {
		int row = table.getSelectedRow();
        if (row<(empl_items.size()-1)) {
            selectAndScroll(row+1);
        }		
	}

 	private void lastEmployee() {
 		int row = table.getSelectedRow();
        if (row<(empl_items.size())) {
            selectAndScroll(empl_items.size()-1);
        }
    }

	
	
 	private void editEmployee() {
 		int row = table.getSelectedRow();
 		if (row>=0  && row<empl_items.size())  {
 			ModelEmployee empl = empl_items.get(row);
 			WDialogEmployee dialog = new WDialogEmployee(this, false, empl);
 			if (dialog.retcode) {
 				empl.setFirstname(dialog.empl.getFirstname());
 				empl.setLastname(dialog.empl.getLastname());
 				empl.setMonthlysalary(dialog.empl.getMonthlysalary());
 				empl.setDeptindex(dialog.empl.getDeptindex());
 				tableUpdate();
 			}
 		}
 	}  // editEmployee

	private void insertEmployee() {
			ModelEmployee empl = new ModelEmployee();
			WDialogEmployee dialog = new WDialogEmployee(this,true,empl); 
			if (dialog.retcode) { 	
				empl_items.add(empl);
				tableUpdate();	    		
			} 		
 	}
	

private void deleteEmployee() {
 		int row = table.getSelectedRow();
 		if (row>=0   && row<(empl_items.size()-1)) {
 			ModelEmployee empl = empl_items.get(row);
 			if (Basis.YesNo("Wollen Sie wirklich diesen Mitarbeiter lschen\n"+
			  "Nachname: "+empl.getLastname()+"\n"+"Vorname: "+empl.getFirstname()+"\n"  , "Datensatz lschen")) {
 				empl_class.delete(empl);
 				tableUpdate();	    		
 			}
 		}
 	}
 		
	private void startSQL() {
		  		String tlastnameFilter = lastnameFilter.getText().trim();
		  		empl_class = Dbs_QueriesExecute.getItemsFromEmployees(tlastnameFilter);
		  		empl_items = empl_class.getItems(); // schneller
		  		tableUpdate();
 	}  // startsql

	private void tableUpdate() {
	    table.tableChanged(new TableModelEvent(dataModel, TableModelEvent.HEADER_ROW));
	    table.updateUI();
	    
	    table.getColumnModel().getColumn(0).setPreferredWidth(70);
		for (int col=1; col<headers.size(); col++) {
	        table.getColumnModel().getColumn(col).setPreferredWidth(180);
	     }	
		
		for (int col=1; col<=headers.size(); col++) {
			TableColumn numbersColumn = table.getColumn(headers.get(col-1));

			// Anonyme Klasse
			DefaultTableCellRenderer numberColumnRenderer= new DefaultTableCellRenderer() { 
				
			};  // DefaultTableCellRenderer
			numberColumnRenderer.setHorizontalAlignment(JLabel.CENTER);
			numbersColumn.setCellRenderer(numberColumnRenderer);
		}		
	}
	
    private boolean getModify() {
        boolean modify = false;
        if (empl_items!=null)  {
	        for (ModelEmployee empl :  empl_items) {
	            if (empl.modifyAttrib) modify = true;
	            if (empl.newAttrib) modify = true;
	        }
	        if (empl_class.getDeleteItemsCount() > 0) modify = true;
    	}
        return modify;
    }
	
    private void this_windowClosing(WindowEvent e) {
    	// wird nur geschlossen, wenn disposed
    	// Check Modify
        if (getModify()) {
            int retcode = Basis.YesNoEsc("Sollen die nderungen gespeichert werden?", "Dialog beenden");
            switch (retcode) {
                case Basis.YES: 
                			empl_class.save2Database(); 
                			this.dispose();
                			break;
                case Basis.NO: 
                			this.dispose();
                			break;
                case Basis.CANCEL: return;
            }
        }
        else {
        	this.dispose();
        }
    }

 	
}