import javax.swing.*;

import java.awt.*;


import java.sql.*;

// schalter
import java.awt.event.*;

import javax.swing.table.*;

import java.util.ArrayList;
import java.util.Vector;
import javax.swing.event.TableModelEvent;

@SuppressWarnings("serial")
public class WSQL extends JDialog implements ActionListener{
	
	
	private JTable table = new JTable(); 
	  
	private JTextArea editor= new JTextArea();
	
	private TableModel dataModel;
	
    
	private DataTable dt=new DataTable();
	
	public WSQL(Frame parent) {
		super(parent);
		setModal(true);
		setSize(900,600);
	    setLocation(400,40);
	    setGUI();
	    
	    setVisible(true);  // muss am Schluss kommen
	}
	    
	private void setGUI() {
	      setLayout( new BorderLayout() );	
	      this.setTitle("SQL-Abfrage");
	      // setToolBar();
	      
	      JPanel panelTop = new JPanel();
	      panelTop.setLayout(new FlowLayout(FlowLayout.RIGHT));
	      JButton bnStart = new JButton("Start SQL");
	      bnStart.setFont( new Font("Arial", Font.BOLD,16));
	      bnStart.addActionListener(this);
	      bnStart.setActionCommand("Start");
	      panelTop.add(bnStart);
	      add(panelTop,BorderLayout.NORTH); 
	      
              editor.setFont( new Font("Arial", Font.PLAIN,24) );

	      table = createTable();
	      table.setFont( new Font("Monospaced", Font.PLAIN,18) );
	      // Splitter  links=Baum   rechts=tabelle
	      JSplitPane split = new JSplitPane(JSplitPane.VERTICAL_SPLIT,false,     
	      new JScrollPane(editor), new JScrollPane(table) );
	      split.setDividerLocation(150);
	      add(split,BorderLayout.CENTER);
	      
	      editor.setText("SELECT * FROM employee");
	}  // setGUI
	
	
    // createTable
 public JTable createTable() {
   // Create a model of the data.
       dataModel = new AbstractTableModel() {
           // These methods always need to be implemented.
           public int getColumnCount() {
               //System.out.println( " **** AnzCol: "+_tupel.size() );
             return dt.headers.size();
           }
           public int getRowCount() {
        	   if (dt.rows.size()==0)  // Am Anfang noch nicht gesetzt
        		   return 0;
        	   else
        		   return dt.rows.size();
           }

               // Speicherung mittels Vector und Vector
           public Object getValueAt(int row, int column) {
        	   ArrayList<String> columnInRow = dt.rows.get(row);
               return columnInRow.get(column);
           }

           public String getColumnName(int column) {
               if ( (column)< dt.headers.size() ) {
					return dt.headers.get(column);
               } else {
                   return "X";
               }
           }
           
           public Class getColumnClass(int column) {
             return getValueAt(0, column).getClass();
           }
           
           public boolean isCellEditable(int row, int col) {
             return false;
           }          
        };

    
    JTable table = new JTable(dataModel); // , _TableColModel);

    table.setFont( new Font("Arial", Font.PLAIN,24) );
    table.setRowHeight(30);
    table.setAutoCreateColumnsFromModel(true);
    
    table.setAutoCreateRowSorter(true);  // Absturz
    
    //table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    

    return table;
 } // createTable
 
 
 	@Override
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		switch (cmd) {
			case "Start": startSQL();
					break;
			default: Basis.Error("Fehlerhafte case-Anweisung in actionPerformed", "Main");
					break;
		}
	}  // actionPerformed 
	
 	
 		
	private void startSQL() {
		String sql = editor.getText().trim();
		if (sql.length()>0) {
			dt = Dbs_QueriesExecute.getSQL(sql);
			tableUpdate();	  
			System.out.println("sss");
		}
 	}  // startsql

	private void tableUpdate() {
	    table.tableChanged(new TableModelEvent(dataModel, TableModelEvent.HEADER_ROW));
	    table.updateUI();
	    System.out.println(dt.headers.size());
	    if (dt.headers.size()>0) {
	    	
		    table.getColumnModel().getColumn(0).setPreferredWidth(70);
			for (int col=1; col<dt.headers.size(); col++) {
		        table.getColumnModel().getColumn(col).setPreferredWidth(180);
		        
		     }	
			
			
			
			// TableColumn numbersColumn =table.getColumn("Favorite Number");
			// numbersColumn.setHorizontalAlignment(JLabel.CENTER);

	    }
	}
	
 	
}